<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Admin | Devcamp-Pizza365</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Admin</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Anh Luong</a>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Devcamp 120
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="orderList.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Order List</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="pizza365.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Pizza 365</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <section class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Order List</li>
              </ol>
            </div>
          </div>
        </div><!-- /.container-fluid -->
      </section>

      <!-- Main content -->
      <section class="content">
        <div class="container">
          <h2 class="text-left">Orders List</h2>
          <div class="jumbotron container">
            <div class="row form-group">
              <div class="col-md-5 row">
                <div class="col-md-6 text-left">
                  <label class="form-group mx-2">Pizza Type</label>
                </div>
                <div class="col-md-6">
                  <select id="select-pizza" class="form-control">
                    <option value="all">All</option>
                    <option value="seafood">Hải Sản</option>
                    <option value="hawaii">Hawaii</option>
                    <option value="bacon">Thịt hun khói</option>
                  </select>
                </div>
              </div>
              <div class="col-md-5 row">
                <div class="col-md-6 text-left">
                  <label class="form-group mx-2">Order Status</label>
                </div>
                <div class="col-md-6">
                  <select id="select-status" class="form-control">
                    <option value="all">All</option>
                    <option value="open">Open</option>
                    <option value="confirmed">Confirmed</option>
                    <option value="cancel">Cancel</option>
                  </select>
                </div>
              </div>
              <div class="col-md-2">
                <div class="col-md-12 text-right">
                  <button class="btn btn-success" id="btn-filter"><i class="fas fa-filter"></i>&nbsp;Filter</button>
                </div>
              </div>
            </div>
          </div>
          <div class="form-group">
            <button class="btn btn-success" id="btn-create-new-order"><i class="fa fa-plus"></i>&nbsp;Create New
              Order</button>
          </div>
          <table id="order-table" class="table table-striped table-bordered table-hover">
            <thead>
              <tr>
                <th>Order Code</th>
                <th>Kích cỡ Combo</th>
                <th>Loại Pizza</th>
                <th>Nước uống</th>
                <th>Thành tiền</th>
                <th>Họ và tên</th>
                <th>Số điện thoại</th>
                <th>Trạng thái</th>
                <th>Action</th>
              </tr>
            </thead>
          </table>
        </div>
        <!-- Modal create order -->
        <div id="create-order-modal" class="modal fade text-left" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content" style="width: 800px;">
              <div class="modal-header">
                <h5 class="modal-title">Create New Order</h5>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
              </div>
              <!-- Modal body -->
              <div class="modal-body">
                <form>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Pizza Size</label>
                    </div>
                    <div class="col-md-8">
                      <select id="select-pizzasize-create" class="form-control">
                        <option value="all">Chọn kích cỡ combo</option>
                      </select>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Đường kính (cm)</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-duongkinh-create" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Số lượng sườn</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-suon-create" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Salad (g)</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-salad-create" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Số lượng nước uống</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-soluongdrink-create" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Thành tiền (VNĐ)</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-thanhtien-create" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Pizza Type</label>
                    </div>
                    <div class="col-md-8">
                      <select id="select-pizza-type-create" class="form-control">
                        <option value="all">Chọn loại Pizza</option>
                        <option value="Seafood">Hải sản</option>
                        <option value="Hawaii">Hawaii</option>
                        <option value="Bacon">Thịt hun khói</option>
                      </select>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Loại đồ uống</label>
                    </div>
                    <div class="col-md-8">
                      <select id="select-drink-create" class="form-control">
                        <option value="all">Chọn loại nước uống</option>
                      </select>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Họ và tên</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-hoten-create" class="form-control" type="text">
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Email</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-email-create" class="form-control" type="text">
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Số điện thoại</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-phone-create" class="form-control" type="text">
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Địa chỉ</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-address-create" class="form-control" type="text">
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">ID Voucher</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-idvoucher-create" class="form-control" type="text">
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Lời nhắn</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-message-create" class="form-control" type="text">
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Status</label>
                    </div>
                    <div class="col-md-8">
                      <select id="select-status-create" class="form-control" disabled>
                        <option value="open">Open</option>
                        <option value="confirmed">Confirmed</option>
                        <option value="cancel">Cancel</option>
                      </select>
                    </div>
                  </div>
                </form>
                <div class="modal-footer">
                  <button id="btn-create-order" class="btn btn-primary">Create</button>
                  <button id="btn-create-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!-- Modal update order -->
        <div id="update-order-modal" class="modal fade text-left" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content" style="width: 800px;">
              <div class="modal-header">
                <h5 class="modal-title">Update Order</h5>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
              </div>
              <!-- Modal body -->
              <div class="modal-body">
                <form>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Pizza Size</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-pizzasize-update" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Pizza Type</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-pizzatype-update" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Loại đồ uống</label>
                    </div>
                    <div class="col-md-8">
                      <select id="select-drink-update" class="form-control" disabled>
                        <option value="all">Chọn loại nước uống</option>
                      </select>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Họ và tên</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-hoten-update" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Email</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-email-update" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Số điện thoại</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-phone-update" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Địa chỉ</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-address-update" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">ID Voucher</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-idvoucher-update" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Lời nhắn</label>
                    </div>
                    <div class="col-md-8">
                      <input id="inp-message-update" class="form-control" type="text" disabled>
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label for="">Status</label>
                    </div>
                    <div class="col-md-8">
                      <select id="select-status-update" class="form-control">
                        <option value="open">Open</option>
                        <option value="confirmed">Confirmed</option>
                        <option value="cancel">Cancel</option>
                      </select>
                    </div>
                  </div>
                </form>
                <div class="modal-footer">
                  <button id="btn-update-order" class="btn btn-primary">Update</button>
                  <button id="btn-update-cancel" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!-- Delete order modal -->
        <div>
          <div class="modal fade" tabindex="-1" id="delete-order-modal">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Xác nhận xóa order</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                  <label>Bạn có chắc muốn xóa order này không?</label>
                </div>
                <div class="modal-footer">
                  <button class="btn btn-danger" id="btn-confirm-delete-order">Xác nhận</button>
                  <button class="btn btn-secondary" data-dismiss="modal">Hủy</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <script>
    "use strict";
    $(document).ready(function () {
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gId;
      var gOrderCode;
      var gDataOrders = []; //khai báo biến array để chứa data order
      var gPizzaSize = ["S", "M", "L"]; //khai báo array chứa giá trị kích cỡ của pizza size
      const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
      const gCOLUMN_ORDER_CODE = 0;
      const gCOLUMN_KICH_CO = 1;
      const gCOLUMN_LOAI_PIZZA = 2;
      const gCOLUMN_ID_LOAI_NUOC_DUNG = 3;
      const gCOLUMN_THANH_TIEN = 4;
      const gCOLUMN_HO_TEN = 5;
      const gCOLUMN_SO_DIEN_THOAI = 6;
      const gCOLUMN_TRANG_THAI = 7;
      const gCOLUMN_ACTION = 8;
      const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders/";
      //định nghĩa table - chưa có data
      var gDataTable = $("#order-table").DataTable({
        "columns": [
          { "data": gORDER[gCOLUMN_ORDER_CODE] },
          { "data": gORDER[gCOLUMN_KICH_CO] },
          { "data": gORDER[gCOLUMN_LOAI_PIZZA] },
          { "data": gORDER[gCOLUMN_ID_LOAI_NUOC_DUNG] },
          { "data": gORDER[gCOLUMN_THANH_TIEN] },
          { "data": gORDER[gCOLUMN_HO_TEN] },
          { "data": gORDER[gCOLUMN_SO_DIEN_THOAI] },
          { "data": gORDER[gCOLUMN_TRANG_THAI] },
          { "data": gORDER[gCOLUMN_ACTION] }
        ],
        //ghi đè nội dung cột action, chuyển thành button Detail
        "columnDefs": [
          {
            "targets": gCOLUMN_ACTION,
            "defaultContent": `
                    <img class="edit-order" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-order" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                    `
          }
        ]
      });
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();
      //gọi hàm hiển thị ds đồ uống vào select
      getDrinkList();
      //gọi hàm hiển thị kích cỡ pizza vào select
      getPizzaSizeList(gPizzaSize);
      //gán sự kiện cho nút Lọc
      $("#btn-filter").on("click", function () {
        onBtnFilterClick();
      });
      //gán sự kiện cho nút Create New Order
      $("#btn-create-new-order").on("click", onBtnCreateNewOrderClick);
      //gán sự kiện cho nút Create(trên modal)
      $("#btn-create-order").on("click", onBtnCreateOrderModalClick);
      //gán sự kiện change cho select chọn kích cỡ khi chọn 1 combo
      $('#select-pizzasize-create').change(function () {
        const size = $(this).val();
        if (size === 'S') {
          $('#inp-duongkinh-create').val(20);
          $('#inp-suon-create').val(2);
          $('#inp-salad-create').val(200);
          $('#inp-soluongdrink-create').val(2);
          $('#inp-thanhtien-create').val(150000);
        } else if (size === 'M') {
          $('#inp-duongkinh-create').val(25);
          $('#inp-suon-create').val(4);
          $('#inp-salad-create').val(300);
          $('#inp-soluongdrink-create').val(3);
          $('#inp-thanhtien-create').val(200000);
        } else if (size === 'L') {
          $('#inp-duongkinh-create').val(30);
          $('#inp-suon-create').val(8);
          $('#inp-salad-create').val(500);
          $('#inp-soluongdrink-create').val(4);
          $('#inp-thanhtien-create').val(250000);
        }
      });
      //gán sự kiện cho nút update order trên table
      $("#order-table").on("click", ".edit-order", function () {
        onBtnUpdateOrderClick(this);
      });
      //gán sự kiện cho nút Update(trên modal)
      $("#btn-update-order").on("click", onBtnUpdateOrderModalClick);
      //gán sự kiện cho nút delete order trên table
      $("#order-table").on("click", ".delete-order", function () {
        onBtnDeleteOrderClick(this);
      });
      //gán sự kiện cho nút Confirm delete(trên modal)
      $("#btn-confirm-delete-order").on("click", onBtnDeleteOrderModalClick);
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        $.ajax({
          url: gBASE_URL,
          type: "GET",
          dataType: "json",
          success: function (res) {
            gDataOrders = res;
            console.log(gDataOrders);
            loadDataToTable(gDataOrders); //gọi hàm load data vào table
          },
          error: function (err) {
            console.assert(err.responseText);
          }
        });
      }
      //hàm xử lý sự kiện nút Lọc
      function onBtnFilterClick() {
        var vStatus = $("#select-status").val();
        var vPizzaType = $("#select-pizza").val();
        var vDataFilter = gDataOrders.filter(function (paramOrder, index) {
          return (vStatus == "all" || vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase())
            && (vPizzaType == "all" || vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
        });
        //gọi hàm load data vào table
        loadDataToTable(vDataFilter);
      }
      //hàm xử lý sự kiện nút Create new order
      function onBtnCreateNewOrderClick() {
        //hiển thị modal trắng lên
        $("#create-order-modal").modal("show");
      }
      //hàm xử lý sự kiện nút Thêm mới(trên modal create)
      function onBtnCreateOrderModalClick() {
        //tạo obj chứa data order
        var vOrderObj = {
          kichCo: "",
          duongKinh: 0,
          suon: 0,
          salad: 0,
          soLuongNuoc: 0,
          thanhTien: 0,
          loaiPizza: "",
          idVourcher: "",
          idLoaiNuocUong: "",
          hoTen: "",
          email: "",
          soDienThoai: "",
          diaChi: "",
          loiNhan: "",
          trangThai: "",
          maGiamGia: "",
          phanTramGiamGia: "",
          giamGia: function () {
            var vGiamGia = this.thanhTien * (this.phanTramGiamGia / 100);
            return vGiamGia;
          }
        };
        // Bước 1: Đọc
        getCreateOrderData(vOrderObj);
        //Bước 2: kiểm tra
        var vKetQuaKiemTra = validateData(vOrderObj);
        if (vKetQuaKiemTra) {
          var vVoucherObj = callApiToGetVoucherObj(vOrderObj.maGiamGia);
          if (vVoucherObj == null) {
            vOrderObj.phanTramGiamGia = 0;
          } else {
            vOrderObj.phanTramGiamGia = vVoucherObj.phanTramGiamGia;
          }
          //Bước 3: Hiển thị
          $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(vOrderObj),
            success: function (paramRes) {
              console.log(paramRes);
              //b4: xử lý front-end        
              handleCreateOrderSuccess();
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            }
          });
        }
      }
      //hàm xử lý sự kiện Update data từ table
      function onBtnUpdateOrderClick(paramUpdate) {
        //lưu thông tin Order Code đang dc edit vào biến toàn cục
        gOrderCode = getOrderCodeFromButton(paramUpdate);
        //lưu thông tin id đang dc edit vào biến toàn cục
        gId = getIdFromButton(paramUpdate);
        console.log("Order Code của data tương ứng = " + gOrderCode);
        // load dữ liệu vào các trường dữ liệu trong modal
        getDataByOrderCode(gOrderCode);
      }
      //hàm xử lý sự kiện nút Cập nhật(trên modal)
      function onBtnUpdateOrderModalClick() {
        //khai báo obj chứa user data
        var vRequestDataObj = {
          trangThai: ""
        }
        //b1: get data
        getUpdateData(vRequestDataObj);
        //b2: validate data(k cần)
        //b3: update data
        $.ajax({
          url: gBASE_URL + gId,
          type: "PUT",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(vRequestDataObj),
          success: function (paramRes) {
            console.log(paramRes);
            //b4: xử lý front-end
            handleUpdateDataSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
      //hàm xử lý sự kiện Delete order từ table
      function onBtnDeleteOrderClick(paramDelete) {
        //lưu thông tin id đang dc xóa vào biến toàn cục
        gId = getIdFromButton(paramDelete);
        console.log("Order Code của data tương ứng = " + gId);
        $("#delete-order-modal").modal("show");
      }
      // hàm xử lý sự kiện delete data modal click
      function onBtnDeleteOrderModalClick() {
        // B1: Thu thập dữ liệu(k có)
        // B2: Validate delete(k có)
        // B3: call api to delete data
        $.ajax({
          url: gBASE_URL + gId,
          type: "DELETE",
          contentType: "application/json;charset=UTF-8",
          success: function (paramRes) {
            // B4: xử lý front-end
            handleDeleteOrderSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm load data vào table
      function loadDataToTable(paramResponseObj) {
        gDataTable.clear(); //xóa trắng data đang có của table
        gDataTable.rows.add(paramResponseObj); //cập nhật data cho table
        gDataTable.draw(); //vẽ lại table
      }

      //hàm gọi api get drink list
      function getDrinkList() {
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
          type: "GET",
          success: function (res) {
            handleDrinkList(res);
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          }
        });
      }

      //hàm tạo option cho select drink
      function handleDrinkList(paramDrink) {
        $.each(paramDrink, function (i, item) {
          $("#select-drink-create").append($("<option>", {
            text: item.tenNuocUong,
            value: item.maNuocUong
          }));
          $("#select-drink-update").append($("<option>", {
            text: item.tenNuocUong,
            value: item.maNuocUong
          }));
        });
      }

      //hàm tạo option cho select pizza size
      function getPizzaSizeList(paramPizza) {
        $.each(paramPizza, function (i, item) {
          $("#select-pizzasize-create").append($("<option>", {
            text: item,
            value: item
          }));
        });
      }

      //hàm thu thập create data
      function getCreateOrderData(paramOrderDataObj) {
        paramOrderDataObj.kichCo = $("#select-pizzasize-create").val();
        paramOrderDataObj.duongKinh = $("#inp-duongkinh-create").val();
        paramOrderDataObj.suon = $("#inp-suon-create").val();
        paramOrderDataObj.salad = $("#inp-salad-create").val();
        paramOrderDataObj.soLuongNuoc = $("#inp-soluongdrink-create").val();
        paramOrderDataObj.thanhTien = $("#inp-thanhtien-create").val();
        paramOrderDataObj.loaiPizza = $("#select-pizza-type-create").val();
        paramOrderDataObj.idVourcher = $("#inp-idvoucher-create").val().trim();
        paramOrderDataObj.idLoaiNuocUong = $("#select-drink-create").val();
        paramOrderDataObj.hoTen = $("#inp-hoten-create").val().trim();
        paramOrderDataObj.email = $("#inp-email-create").val().trim();
        paramOrderDataObj.soDienThoai = $("#inp-phone-create").val().trim();
        paramOrderDataObj.diaChi = $("#inp-address-create").val().trim();
        paramOrderDataObj.loiNhan = $("#inp-message-create").val().trim();
        paramOrderDataObj.trangThai = $("#inp-status-create").val();
      }
      //hàm validate data
      function validateData(paramOrderDataObj) {
        if (paramOrderDataObj.kichCo === "all") {
          alert("Hãy chọn kích cỡ combo pizza!");
          return false;
        }
        if (paramOrderDataObj.loaiPizza === "all") {
          alert("Hãy chọn loại pizza!");
          return false;
        }
        if (paramOrderDataObj.idLoaiNuocUong === "all") {
          alert("Hãy chọn loại nước uống!");
          return false;
        }
        if (paramOrderDataObj.hoTen === "") {
          alert("Chưa nhập họ và tên!");
          return false;
        }
        if (isEmail(paramOrderDataObj.email) == false) {
          return false;
        }
        if (paramOrderDataObj.soDienThoai === "") {
          alert("Chưa nhập số điện thoại!");
          return false;
        }
        if (paramOrderDataObj.diaChi === "") {
          alert("Chưa nhập địa chỉ!");
          return false;
        }
        return true;
      }
      //hàm kiểm tra email
      function isEmail(paramEmail) {
        if (paramEmail !== "") {
          if (paramEmail.indexOf("@") === -1) {
            alert("Email phải có ký tự @");
            return false;
          }
          if (paramEmail.startsWith("@") === true) {
            alert("Email không bắt đầu bằng @");
            return false;
          }
          if (paramEmail.endsWith("@") === true) {
            alert("Email không kết thúc bằng @");
            return false;
          }
        }
        return true;
      }
      //hàm gọi api để check mã giảm giá
      function callApiToGetVoucherObj(paramVoucherId) {
        "use strict";
        var vVoucherObj = null;
        var vVoucherId = $("#inp-idvoucher-create");
        paramVoucherId = vVoucherId.val().trim();
        // nếu mã giảm giấ đã nhập, tạo xmlHttp  request và gửi về server
        if (paramVoucherId !== "") {
          $.ajax({
            url: "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail/" + paramVoucherId,
            type: "GET",
            async: false,
            success: function (paramRes) {
              vVoucherObj = paramRes;
              console.log(vVoucherObj);
            },
            error: function () {
              // không nhận lại được data do vấn đề gì đó: khả năng mã voucher không dúng
              console.log("Không tìm thấy voucher " + paramVoucherId);
              alert("Mã giảm giá không tồn tại!");
              return null;
            }
          });
          return vVoucherObj;
        }
      }
      //hàm xử lý front-end khi tạo order thành công
      function handleCreateOrderSuccess() {
        alert("Create new order successfully!");
        window.location.reload();
        loadDataToTable(gDataOrders);
        $("#create-order-modal").modal("hide");
        resetCreateOrderForm();
      }
      //hàm xóa trắng form send order
      function resetCreateOrderForm() {
        $("#select-pizzasize-create").val("all");
        $("#inp-duongkinh-create").val("");
        $("#inp-suon-create").val("");
        $("#inp-salad-create").val("");
        $("#inp-soluongdrink-create").val("");
        $("#inp-thanhtien-create").val("");
        $("#select-pizza-type-create").val("all");
        $("#inp-idvoucher-create").val("");
        $("#select-drink-create").val("all");
        $("#inp-hoten-create").val("");
        $("#inp-email-create").val("");
        $("#inp-phone-create").val("");
        $("#inp-address-create").val("");
        $("#inp-message-create").val("");
      }
      //hàm xác định dc ordercode của data
      function getOrderCodeFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vRowData = gDataTable.row(vTableRow).data();
        return vRowData.orderCode;
      }
      //hàm xác định dc id của data
      function getIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vRowData = gDataTable.row(vTableRow).data();
        return vRowData.id;
      }
      //hàm load data lên update modal form
      function getDataByOrderCode(paramOrderCode) {
        $.ajax({
          url: gBASE_URL + paramOrderCode,
          type: "GET",
          success: function (paramOrderCode) {
            showOrderDataToUpdateModal(paramOrderCode);
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
        // hiển thị modal lên
        $("#update-order-modal").modal("show");
      }
      //hàm show data lên update modal form
      function showOrderDataToUpdateModal(paramDataObj) {
        $("#inp-pizzasize-update").val(paramDataObj.kichCo);
        $("#inp-pizzatype-update").val(paramDataObj.loaiPizza);
        $("#select-drink-update").val(paramDataObj.idLoaiNuocUong);
        $("#inp-hoten-update").val(paramDataObj.hoTen);
        $("#inp-email-update").val(paramDataObj.email);
        $("#inp-phone-update").val(paramDataObj.soDienThoai);
        $("#inp-address-update").val(paramDataObj.diaChi);
        $("#inp-idvourcher-update").val(paramDataObj.idVourcher);
        $("#inp-message-update").val(paramDataObj.loiNhan);
        $("#select-status-update").val(paramDataObj.trangThai);
      }
      //hàm thu thập update data
      function getUpdateData(paramDataObj) {
        paramDataObj.trangThai = $("#select-status-update").val();
      }
      //hàm xử lý front-end khi update data thành công
      function handleUpdateDataSuccess() {
        alert("Update order successfully!");
        window.location.reload();
        loadDataToTable(gDataOrders);
        $("#update-order-modal").modal("hide");
      }
      //hàm xử lý front-end khi delete order thành công
      function handleDeleteOrderSuccess() {
        alert("Delete order successfully!");
        window.location.reload();
        loadDataToTable(gDataOrders);
        $("#delete-order-modal").modal("hide");
      }
    });
  </script>
</body>

</html>